2 # git-mergetool--lib is a library for common merge tool functions
4 test "$TOOL_MODE" = diff
8 test "$TOOL_MODE" = merge
11 translate_merge_tool_path
() {
16 if test "$MERGED" -nt "$BACKUP"
22 echo "$MERGED seems unchanged."
23 printf "Was the merge successful? [y/n] "
24 read answer ||
return 1
26 y
*|Y
*) status
=0; break ;;
27 n
*|N
*) status
=1; break ;;
33 valid_tool_config
() {
34 if test -n "$(get_merge_tool_cmd "$1")"
43 setup_tool
"$1" || valid_tool_config
"$1"
55 mergetools
="$(git --exec-path)/mergetools"
57 # Load the default definitions
58 .
"$mergetools/defaults"
59 if ! test -f "$mergetools/$tool"
64 # Load the redefined functions
67 if merge_mode
&& ! can_merge
69 echo "error: '$tool' can not be used to resolve merges" >&2
71 elif diff_mode
&& ! can_diff
73 echo "error: '$tool' can only be used to resolve merges" >&2
79 get_merge_tool_cmd
() {
80 # Prints the custom command for a merge tool
84 echo "$(git config difftool.$merge_tool.cmd ||
85 git config mergetool.$merge_tool.cmd)"
87 echo "$(git config mergetool.$merge_tool.cmd)"
91 # Entry point for running tools
93 # If GIT_PREFIX is empty then we cannot use it in tools
94 # that expect to be able to chdir() to its value.
95 GIT_PREFIX
=${GIT_PREFIX:-.}
98 merge_tool_path
="$(get_merge_tool_path "$1")" ||
exit
102 # Bring tool-specific functions into scope
114 # Run a either a configured or built-in diff tool
116 merge_tool_cmd
="$(get_merge_tool_cmd "$1")"
117 if test -n "$merge_tool_cmd"
119 ( eval $merge_tool_cmd )
127 # Run a either a configured or built-in merge tool
129 merge_tool_cmd
="$(get_merge_tool_cmd "$1")"
130 if test -n "$merge_tool_cmd"
132 trust_exit_code
="$(git config --bool \
133 mergetool."$1".trustExitCode || echo false)"
134 if test "$trust_exit_code" = "false"
137 ( eval $merge_tool_cmd )
141 ( eval $merge_tool_cmd )
150 list_merge_tool_candidates
() {
153 tools
="tortoisemerge"
157 if test -n "$DISPLAY"
159 if test -n "$GNOME_DESKTOP_SESSION_ID"
161 tools
="meld opendiff kdiff3 tkdiff xxdiff $tools"
163 tools
="opendiff kdiff3 tkdiff xxdiff meld $tools"
165 tools
="$tools gvimdiff diffuse ecmerge p4merge araxis bc3 codecompare"
167 case "${VISUAL:-$EDITOR}" in
169 tools
="$tools vimdiff emerge"
172 tools
="$tools emerge vimdiff"
178 list_merge_tool_candidates
179 unavailable
= available
= LF
='
183 merge_tool_path
=$
(translate_merge_tool_path
"$i")
184 if type "$merge_tool_path" >/dev
/null
2>&1
186 available
="$available$i$LF"
188 unavailable
="$unavailable$i$LF"
191 if test -n "$available"
193 echo "'git mergetool --tool=<tool>' may be set to one of the following:"
194 echo "$available" |
sort |
sed -e 's/^/ /'
196 echo "No suitable tool for 'git mergetool --tool=<tool>' found."
198 if test -n "$unavailable"
201 echo 'The following tools are valid, but not currently available:'
202 echo "$unavailable" |
sort |
sed -e 's/^/ /'
204 if test -n "$unavailable$available"
207 echo "Some of the tools listed above only work in a windowed"
208 echo "environment. If run in a terminal-only session, they will fail."
213 guess_merge_tool
() {
214 list_merge_tool_candidates
215 echo >&2 "merge tool candidates: $tools"
217 # Loop over each candidate and stop when a valid merge tool is found.
220 merge_tool_path
="$(translate_merge_tool_path "$i")"
221 if type "$merge_tool_path" >/dev
/null
2>&1
228 echo >&2 "No known merge resolution program available."
232 get_configured_merge_tool
() {
233 # Diff mode first tries diff.tool and falls back to merge.tool.
234 # Merge mode only checks merge.tool
237 merge_tool
=$
(git config
diff.tool || git config merge.tool
)
239 merge_tool
=$
(git config merge.tool
)
241 if test -n "$merge_tool" && ! valid_tool
"$merge_tool"
243 echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
244 echo >&2 "Resetting to default..."
250 get_merge_tool_path
() {
251 # A merge tool has been set, so verify that it's valid.
253 if ! valid_tool
"$merge_tool"
255 echo >&2 "Unknown merge tool $merge_tool"
260 merge_tool_path
=$
(git config difftool.
"$merge_tool".path ||
261 git config mergetool.
"$merge_tool".path
)
263 merge_tool_path
=$
(git config mergetool.
"$merge_tool".path
)
265 if test -z "$merge_tool_path"
267 merge_tool_path
="$(translate_merge_tool_path "$merge_tool")"
269 if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
270 ! type "$merge_tool_path" >/dev
/null
2>&1
272 echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
276 echo "$merge_tool_path"
280 # Check if a merge tool has been configured
281 merge_tool
="$(get_configured_merge_tool)"
282 # Try to guess an appropriate merge tool if no tool has been set.
283 if test -z "$merge_tool"
285 merge_tool
="$(guess_merge_tool)" ||
exit